
;
; rrr & bc! love production 2004
; written by ville helin <vhelin@iki.fi>
;

.include "defines.i"

;
; main
;

.bank 0 slot 0
.org $150

MAIN:	di
	ld	sp, $C1FF
	call	SET_CPU_SPEED_2X

	ld	a, $D9			;reti.
	ld	(IRQ_LCD), a		;empty all interrupts.
	ld	(IRQ_TIM), a
	ld	(IRQ_SER), a
	ld	(IRQ_HTL), a
	ld	(IRQ_VBI), a

	ld	hl, IRQ_VBI
	ld	a, $C3			;jp.
	ld	(hl+), a
	ld	bc, SM4x4_VBI
	ld	a, c
	ld	(hl+), a
	ld	(hl), b

	call	VBI_WAIT_POWER

	ld	a, %10010001
	ld	($ff00+R_LCDC), a	;lcd control.

	ld	a, $0A
	ld	($0000), a		;enable cart ram.

;
; 4x1 init
;

	call	SCREEN_OFF
	call	SM4x4_INIT
	call	SCREEN_ON

	; wait until ly == 144 (no lcd irqs this frame)
-	ld	a, ($ff00+R_LY)
	cp	144
	jr	nz, -

	ld	hl, DAT_PALETTE
	call	PALETTE_LOAD_BG

;
; enable interrupts
;

	; set the vblank to occur	
	ld	a, %00000001
	ld	($ff00+R_IF), a

	ld	a, %00001000
	ld	($ff00+R_STAT), a	;lcd 00 irq.
	ld	a, %00000011
	ld	($ff00+R_IE), a		;enable lcd & vbi.
	ei

;
; battery saving main loop
;

-	halt
	nop
	jr	-

;
; data
;

	; animation frames
DAT_LOGO1:
	.incdir ""
	.include "data/logo1.s"

	; animation loop
ANIM_FRAMES:
	.dw DAT_LOGO1

	; palette
DAT_PALETTE:
	.dw $0000, $1000, $2000, $3000
